# ========= $NAME =========
# symbolic name of the database (defaults to name of file, lowercase)
$NAME = 'moviedb';

# ========= $HOST  =========
# name of the host to connect to
$HOST = 'localhost';

# ========= $PORT  =========
# Port number to connect to
$PORT = 200008;

# ========= $STYLESHEET =========
# stylesheet to use
$STYLESHEET = 'http://stein.cshl.org/stylesheets/aceperl.css';

# ========= $PICTURES ==========
# Where to write temporary picture files to:
#   The URL and the physical location, which must be writable
# by the web server.
# You probably will have to change this.
@PICTURES = ('/ace_images' => '/var/tmp/ace_images');

# ========= @SEARCHES  =========
# search scripts available
# NOTE: the order is important
@SEARCHES   = (
               'searches/basic'   => 'Basic Search',
	       'searches/text'    => 'Text Search',
	       'searches/browser' => 'Class Browser',
	       'searches/query'   => 'Acedb Query',
	       );
$SEARCH_ICON = '/icons/unknown.gif';

# ========= %HOME  =========
# Home page URL
@HOME      = (
	      'http://stein.cshl.org/AcePerl' => "AcePerl Home Page"
	     );

# ========= %DISPLAYS =========
# displays to show
my $ROOT = '/perl/ace/moviedb';

%DISPLAYS = (
	     movie => {
		 url   => "$ROOT/movie",
		 label => 'Movie Report',
		 icon  => '/icons/layout.gif',
		 },
    
	     person => {
		 url   => "$ROOT/person",
		 label => 'Person Profile',
		 icon  => '/icons/layout.gif',
		 },
	     
	     tree => { 
		 'url'     => "generic/tree",
		 'label'   => 'Tree Display',       
		 'icon'    => '/icons/text.gif' },
	     pic => { 
		 'url'     => "generic/pic",
		 'label'   => 'Graphic Display',    
		 'icon'    => '/icons/image2.gif' },
	     );

# ========= %CLASSES =========
# displays to show
%CLASSES = (
	    Person => ['person'],
	    Movie  => ['movie'],
	    # default is a special "dummy" class to fall back on
	    Default => [ qw/tree pic/ ],
	    );

# ========= &URL_MAPPER  =========
# mapping from object type to URL.  Return empty list to fall through
# to default.
sub URL_MAPPER {
  my ($display,$name,$class) = @_;

  # Small Ace inconsistency: Models named "#name" should be
  # transduced to Models named "?name"
  $name = "?$1" if $class eq 'Model' && $name=~/^\#(.*)/;
    
  my $n = CGI::escape("$name"); # looks superfluous, but avoids Ace::Object name conversions errors
  my $c = CGI::escape($class);
  
  return ('person'    => "name=$n") if $class eq 'Person';
  return ('movie'     => "name=$n") if $class eq 'Movie';
  return ('tree' => "name=$n&class=$c");
}

# ========= $BANNER =========
# Banner HTML
# This will appear at the top of each page. 
$BANNER = <<END;
<center><span class=banner><font size=+3>Movie Database (Test)</font></span></center><p>
END

# ========= $FOOTER =========
# Footer HTML
# This will appear at the bottom of each page
$FOOTER = '';

# configuration for the "basic" seqarch script
@BASIC_OBJECTS = 
  ('Any'       =>   '<i>Anything</i>',
   'Movie'     =>   'Movie Title',
   'Person'    =>   'Person (author/actor/director)',
   'Director'  =>   'Director',
   'Author'    =>   'Author',
   'Actor'     =>   'Actor',
   'Book'      =>   'Book');
1;
