#!/usr/bin/perl

use strict;

die "This must be run from the ACEDB home directory (the one containing wspec/ etc)"
    unless -d "./wspec";

warn "Patching your wspec, don't be alarmed\n";

open (PATCH,"| patch -p0 ") || die "Couldn't start patch process: $!";
open (W,"wormbase_patches/wspec.patch") || die "Couldn't open patch file";
while (<W>) {
  print PATCH;
}
close W;
close PATCH;

warn "Adding your login to the passwd file as the administrator.\n";
my $whoami;
chomp($whoami  = `whoami`);

open (PASSWD,">>wspec/passwd.wrm") || die "Can't append to passwd.wrm: $!";
print PASSWD $whoami;
close PASSWD;

warn "Rewriting your database.  This may take awhile.  Be patient and watch the ACEDB messages.\n";
open (TACE,"| tace .") || die "Couldn't start tace process: $!";
print TACE <<END;
read-models
parse wormbase_patches/atlas.ace
parse wormbase_patches/clone_patch.ace
parse wormbase_patches/meta.jade.ace
parse wormbase_patches/tables.ace
save
quit
END
close TACE;

