#!/opt/bin/perl -w

# make_pic.cgi by Marco Mangone (mang1);
# this program create on-line map positions on a chromosome
# require chromosome.png so do not forget to copy on the same directory
# this program is part of hunter.cgi, so put it on the same directory

use lib '..','../..';

use strict;
use File::stat;
use GD;
use CGI qw/:standard :html3 escape/;
use CGI::Carp qw/fatalsToBrowser/;
use Ace 1.51;
use AceSubs;

#acquire the parameters
my $cell =  param('cell'); 

#start Ace
my $top_level = 0;

# start Ace
my $DB = OpenDatabase() || AceError("Couldn't open database.");

#WITH THIS I FOUND 1-2-4-5
my $results = $DB->fetch(-class=>'Cell',
			  -name=>$cell);

if (!defined($results)){
  No_pedigree();
  exit 0;
}

my $cell_1 = $results->get('Parent'=>1);
if (!$cell_1) {  #oops, at the top
  $cell = ($results->get('Daughter'=>1))[1];
  $cell_1 = $cell->Parent;
  $results = $cell->fetch;
  $top_level++;
}

my @cell_2= $results->get('Daughter'=>1);

#with this I found 3
my $results1 = $cell_1->fetch if ref $cell_1;

my @cell_3 = $results1->get('Daughter'=>1) if ref $results1;

#with this I found 6 -6
@cell_3 = reverse @cell_3 if $cell_3[0] eq $cell;
my $results2 = $cell_3[0]->fetch if ref $cell_3[0];

my @cell_4= $results2->get('Daughter'=>1) if ref $results2;

# start the picture
print header($GD::VERSION > 1.19 ? 'image/png' : 'image/gif');

open (GIF,$GD::VERSION > 1.19 ? "pedigree.png" : "pedigree.gif") || die;
my $myImage = $GD::VERSION > 1.19 ? GD::Image->newFromPng(\*GIF) : GD::Image->newFromGif(\*GIF) || die;
close GIF;

my $white = $myImage->colorAllocate(255,255,255);
my $red = $myImage->colorAllocate(255,0,0);
my $blue = $myImage->colorAllocate(0,48,238);
my $black = $myImage->colorAllocate(0,0,0);
$myImage->transparent($white);

#1
$myImage->string(gdSmallFont,145,30,$cell_1,$top_level ? $red : $black) 
  if ref $cell_1;

#2
$myImage->line(150,47,150,65,$blue);
$myImage->line(150,65,225,65,$blue);
$myImage->line(225,65,225,85,$blue);
$myImage->string(gdSmallFont,215,93,$cell,$top_level ? $black : $red);

#3
if ((defined($cell_3[0]))&&($cell ne $cell_3[0])){
    $myImage->line(150,47,150,65,$blue);
    $myImage->line(150,65,75,65,$blue);
    $myImage->line(75,65,75,85,$blue);
    $myImage->string(gdSmallFont,65,93,$cell_3[0],$black);
}


#4
if ((defined($cell)) &&(defined($cell_2[0]))){
    $myImage->line(225,110,225,130,$blue);
    $myImage->line(225,130,190,130,$blue);
    $myImage->line(190,130,190,150,$blue);
    $myImage->string(gdSmallFont,175,160,$cell_2[0],$black);
}


#5
if (defined($cell_2[1])){
    $myImage->line(225,110,225,130,$blue);
    $myImage->line(225,130,260,130,$blue);
    $myImage->line(260,130,260,150,$blue);
    $myImage->string(gdSmallFont,246,160,$cell_2[1],$black);
}


#6
if ((defined($cell_4[0]))&&($cell_4[0] ne $cell_2[0])){
    $myImage->line(75,110,75,130,$blue);
    $myImage->line(75,130,40,130,$blue);
    $myImage->line(40,130,40,150,$blue);
    $myImage->string(gdSmallFont,27,160,$cell_4[0],$black);
}

#7
if ((defined($cell_4[0]))&&($cell_4[1] ne $cell_2[1])){
    $myImage->line(75,110,75,130,$blue);
    $myImage->line(75,130,110,130,$blue);
    $myImage->line(110,130,110,150,$blue);
    $myImage->string(gdSmallFont,100,160,$cell_4[1],$black);
}

print $GD::VERSION > 1.19 ? $myImage->png : $myImage->gif;

sub No_pedigree {
  print $GD::VERSION > 1.19 ? "Content-type: image/png\n\n" : "Content-type: image/gif\n\n";
  open (GIF,$GD::VERSION > 1.19 ? "no_pedigree.png" : "no_pedigree.gif") || die;
  my $myImage = $GD::VERSION > 1.19 ? GD::Image->newFromPng(\*GIF) : GD::Image->newFromGif(\*GIF) || die;
  close GIF;
  print $GD::VERSION > 1.19 ? $myImage->png : $myImage->gif;
}
